#pragma once
#include <IoTComponent.hpp>
#include <ExpansionCard.hpp>
#include <DigitalOutputCard.hpp>

class DigitalOutputIoT : public IoTComponent {
    public:
        bool begin(ExpansionCard *card);
        void handleMqttMessage(char *topic, char *payload);
        void publishDigitalOutputs();
        void publishDigitalOutput(uint8_t pin);
        void setDigitalOutputsPublishEnabled(bool enabled);
        void handleValueChange(uint8_t pin, uint8_t value);
        void registerValueChangeCallback(void (*callback)(uint8_t, bool, uint16_t));
    private:
        bool digital_outputs_publish_enabled = false;
        bool processSetStateMessage(char *topic, char *payload, uint8_t topic_length);
        bool processSetValueMessage(char *topic, char *payload, uint8_t topic_length);
        bool processRequestStateMessage(char *topic, char *payload, uint8_t topic_length);
        DigitalOutputCard *card;
        uint8_t set_state_length;
        uint8_t set_value_length;
        uint8_t state_length;
        uint8_t value_length;
        uint8_t request_state_length;
        uint8_t publish_enable_length;
};